<!DOCTYPE html>
<html xmlns:th="http://www.thymeleaf.org">

<html>

<head>

  <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.11.2/css/all.css" rel="stylesheet"
    type="text/css" />
  <!-- Vue.js を読み込む -->
  <script src="webjars/vue/2.6.11/vue.min.js"></script>
  <script src="webjars/axios/0.19.2/dist/axios.min.js"></script>
  <script src="https://unpkg.com/vue-cookies@1.5.12/vue-cookies.js"></script>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <style>
    body {
      margin: 0;
      font-family: Arial, Helvetica, sans-serif;
    }

    .topnav {
      overflow: hidden;
      background-color: #333;
      position: fixed;
      top: 0;
      width: 100%;
    }

    .topnav a {
      float: left;
      color: #f2f2f2;
      text-align: center;
      padding: 14px 16px;
      text-decoration: none;
      font-size: 17px;
    }

    .topnav p {
      float: left;
      color: #f2f2f2;
      text-align: center;
      padding: 2px 16px;
      text-decoration: none;
      font-size: 17px;
    }

    .topnav a.active {
      background-color: #4CAF50;
      color: white;
    }

    .topnav-right {
      float: right;
    }

    .main {
      margin: 80px 10px 80px;
    }

    .container {
      border: 2px solid #dedede;
      background-color: #f1f1f1;
      border-radius: 5px;
      padding: 10px;
      margin: 10px 0;
    }

    .darker {
      border-color: #ccc;
      background-color: #ddd;
    }

    .container::after {
      content: "";
      clear: both;
      display: table;
    }

    .container img {
      float: left;
      max-width: 60px;
      width: 100%;
      margin-right: 20px;
      border-radius: 50%;
    }

    .container i {
      float: left;
      max-width: 60px;
      width: 100%;
      margin-right: 20px;
      border-radius: 50%;
    }

    .container img.right {
      float: right;
      margin-left: 20px;
      margin-right: 0;
    }

    .container i.right {
      float: right;
      margin-left: 20px;
      margin-right: 0;
    }

    .time-right {
      float: right;
      color: #aaa;
    }

    .time-left {
      float: left;
      color: #999;
    }

    .bottom_nav {
      overflow: hidden;
      background-color: #333;
      position: fixed;
      bottom: 0;
      width: 100%;
    }

    .bottom_nav a {
      float: left;
      display: block;
      color: #f2f2f2;
      text-align: center;
      padding: 14px 16px;
      text-decoration: none;
      font-size: 17px;
    }

    .bottom_nav a:hover {
      background: #f1f1f1;
      color: black;
    }

    .bottom_nav a.active {
      float: right;
      width: 15%;
      background-color: #4CAF50;
      color: white;
    }

    /* Style the search box inside the navigation bar */
    .bottom_nav input[type=text] {
      float: left;
      padding: 6px;
      margin-left: 10px;
      width: 70%;
      border: none;
      margin-top: 8px;
      margin-right: 16px;
      font-size: 17px;
    }

    /* When the screen is less than 600px wide, stack the links and the search field vertically instead of horizontally */
    @media screen and (max-width: 600px) {

      .bottom_nav a,
      .bottom_nav input[type=text] {
        float: none;
        display: block;
        text-align: left;
        width: 100%;
        margin: 0;
        padding: 14px;
      }

      .bottom_nav input[type=text] {
        border: 1px solid #ccc;
        margin-bottom: 20px;
      }

      .main {
        margin: 80px 10px 140px;
      }
    }
  </style>
</head>

<body>
  <div id="app">
    <div class="topnav">
      <a>Spring Chat Room</a>
      <div class="topnav-right">
        <!-- <a href="/logout">Logout</a> -->
        <!-- <a href="https://www.google.com/accounts/Logout">Logout</a> -->
        <!-- <a @click="logout">Logout</a> -->

      </div>
    </div>

    <div class="main">
      <div class="container" v-for="(msg,index) in msgArray">
        <!-- for文で受け取ったデータの反復処理 -->
        <i>{{msg.name}}</i>
        <!--メッセージを書き込んだユーザ名を表示する-->
        <!-- <i>{{msg.name}} - {{index}}</i> -->
        <div v-if="msg.name === username">
          <!-- 自端末でログインしているユーザ名とメッセージを書き込んだユーザ名が一致していたら顔画像が白色になる -->
          <i class="far fa-smile" style="font-size:60px;"></i>
        </div>
        <div v-else>
          <!-- その他のユーザの場合は顔画像が黒色になる -->
          <i class="fas fa-smile" style="font-size:60px;"></i>
        </div>
        <p>{{msg.message}}</p> <!-- 書き込んだメッセージを表示する -->

        <span class="time-right">{{msg.updated_time}}</span><!-- メッセージ書込み日時を表示する -->
      </div>

    </div>
    <!-- <h1 th:text="${username}"></h1>thymeleafの処理、取得したユーザ名を表示する -->
    <div class="bottom_nav">
      <!-- メッセージ入力欄とSendボタンを表示 -->
      <input v-model="inputMsg" type="text" placeholder="Search.." name="search">
      <a @click="insertMsg" class="active">Send</a>
    </div>
  </div>
  <!--/* javascript側の処理、ThymeleafでJavaScriptを利用する場合は、
    1. <script>要素に th:inline="javascript" を追加する。
    2. /*<![CDATA[*/ …… /*]]>*/でJavaScriptのコードを囲う。
    3. /*[[ …… ]]*/で囲うことでThymeleafから値を受け取れる。*/-->
  <script th:inline="javascript">
    /*<![CDATA[*/
    new Vue({     //Vueインスタンスの作成
      el: "#app", //#app-1要素に対してVueを適用する。Vueが適用された範囲内ではjavascript側で保持する変数の値に変換される
      data: {     // inputMsgやusername等のデータを定義している
        msgArray: [],
        inputMsg: null,
        username: /*[[${username}]]*/ 'unknown'
      },
      methods: {
        insertMsg: function () {                 /*Sendボタンが押された時のイベントハンドラとして呼び出されるメソッドを定義*/
          axios                                  /*getメソッドで通信するためのURLを指定、thenメソッドで通信が成功したときの処理*/
            .get('/insert_chat/' + this.inputMsg)/*登録したメッセージを取ってきてURLを指定*/
            .then(response => (this.msgArray = response.data))/*response.dataにデータが返る*/
        }
      },
      mounted: function () {
        axios
          .get('/select_chat')
          .then(response => (this.msgArray = response.data))
        // this.username = /*[[${username}]]*/ 'unknown';
        console.log(this.username);
        // console.log(this.msgArray);
      }
    })
    /*]]>*/
  </script>

    <!-- メールテスト -->
  <form th:action="@{/mail}" method="post" >
    <input type="submit" name="mailsend" value="テストメール送信" />
  </form>

</body>

</html>